<?php 
/*
 * RWE Smarthome state varbiale triggers synthesised speech output on Sonos wireles speakers
 * @author     Smarter user from  link: http://www.rwe-smarthome-forum.de
 * @date 2/March/2014
 * 
 * PhpSonos.Inc.php  class        link: http://www.ip-symcon.de/forum/attachment.php?attachmentid=5313&d=1247152705
 * RWE SmartHome.php class        link: https://raw.github.com/Bubelbub/RWE-SmartHome-PHP/master/SmartHome.class.php
 * SmartHome michaelano Utilities ink: http://www.rwe-smarthome-forum.de/attachment.php?aid=925
 */
//----Sonos class------------------------------------------------------------------------------------
include("PHPSonos.inc.php");  
//----RWE Smarthome class-----------------------------------------------------------------------------
require_once 'SmartHome-PHP-master/SmartHome.php';
require_once 'SmartHome-PHP-master/Request/BaseRequest.php';
require_once 'SmartHome-PHP-master/Request/LoginRequest.php';
require_once 'SmartHome-PHP-master/Request/GetEntitiesRequest.php';
require_once 'SmartHome-PHP-master/Request/GetShcInformationRequest.php';
require_once 'SmartHome-PHP-master/Request/GetAllLogicalDeviceStatesRequest.php';
require_once 'SmartHome-PHP-master/Request/GetApplicationTokenRequest.php';
require_once 'SmartHome-PHP-master/Request/GetShcTypeRequest.php';
require_once 'SmartHome-PHP-master/Request/GetAllPhysicalDeviceStatesRequest.php';
require_once 'SmartHome-PHP-master/Request/GetMessageListRequest.php';
//-----michaelano utilities--------------------------------------------------------------------------
require_once 'michaelano/SmartHome-Utils.php';
set_include_path('/var/www/sonos');
// --- init variables
$newLine             = php_sapi_name() == 'cli' ? "\n" : '<br />';
$configcachefile     = 'Configuration.cache';               #file name
$configIniFile       = __DIR__ . '/config.ini';
$hostname            = "192.168.999.999";                    #SmartHome Zentrale
$userid              = "xyz";
$passwd              = "xy";
$triggerNameprefix   = "Sonos";                             # required prefix in state variable prefix within Smarthome    e.g Sonos_dog_192.178.168.025
$lengtNameprefix     =  strlen($triggerNameprefix);         # character lenght of prefix
$optdebug            = false;
// Get all logical devices states
$sh = michaelano\SmartHomePHP\SmartHomeLogin($configIniFile,$hostname,$userid,$passwd);
$CONFIGR = michaelano\SmartHomePHP\GetConfigR($sh,$configcachefile, $optdebug);
$ROOMS   = $CONFIGR['Rooms'];                   
$BDS     = $CONFIGR['BDs']  ;               
$LDS     = $CONFIGR['LDs']  ;                 
$devstates = $sh->getAllLogicalDeviceStates();if ($optdebug)  {  echo '<pre>' , print_r($devstates), '</pre>';} 
$LDSARR = $devstates->States->LogicalDeviceState;

foreach ($LDSARR as $LD)  #foreach (logical device
    {
    $LID         = $LD["LID"]->__toString();  if ($optdebug){echo $LID.$newLine;}
    $ROOM        = $LDS["$LID"][4];           if ($optdebug){echo $ROOM.$newLine;}
    $LDNAME      = $LDS["$LID"][0];           if ($optdebug){echo $LDNAME.$newLine;}
    $leftLDNAME  = substr($LDNAME,0,$lengtNameprefix);    
if ( $leftLDNAME == $triggerNameprefix){     
    $VALUE       = isset ($LD->Ppts->Ppt["Value"]) ? $LD->Ppts->Ppt["Value"]->__toString() : null;       if ($optdebug){echo $VALUE.$newLine;}
    $action = substr($LDNAME,6,strlen($LDNAME) -$lengtNameprefix);
    
     if($VALUE== "True" )       {
        echo  "".$action.""  . $newLine;
       $GO= playstuff($action);       
        }
         else {
                 {echo  "Zustandsvariable " .$LDNAME. " nicht aktiv" .$newLine;}   
                }
    }  
 
 }                  
            

function playstuff($action)
{
switch ($action) {
    case "radio":
        playradio();
        break;
    case "alarm":
        playalarm();
        break;
    case "bathon":
        playbath();
        break;
    case "bathoff":
        stopbath();
        break;
    case "stopall":
        stopall();
        break;
    case "window":
        playwindow();
        break;
    case "autobath":
        playautobath();
        break;
}
}

function playradio()
{
  $url = "http://192.168.1.100/sonos/sonos2.php?zonen=esszimmer&action=group";
  $xml = simpleXML_load_file($url);
  flush();
  sleep(2);
  $url = "http://192.168.1.100/sonos/sonos2.php?zonen=esszimmer&action=setradio";
  $xml = simpleXML_load_file($url);
  $url = "http://192.168.1.100/sonos/sonos2.php?zonen=wohnzimmer&action=volumeup";
  $xml = simpleXML_load_file($url);
  $url = "http://192.168.1.100/sonos/sonos2.php?zonen=bad&action=mute&mute=true";
  $xml = simpleXML_load_file($url);
  echo "sleep for 15 seconds" . $newLine;
  flush();
  sleep(15);
}

function playalarm()
{
  $url = "http://192.168.1.100/sonos/sonos2.php?zonen=esszimmer&action=group";
  $xml = simpleXML_load_file($url);
  flush();
  sleep(2);
  $url = "http://192.168.1.100/sonos/sonos2.php?zonen=esszimmer&action=message&message=1";
  $xml = simpleXML_load_file($url);
}

function playbath()
{
  $url = "http://192.168.1.100/sonos/sonos2.php?zonen=bad&action=mute&mute=false";
  $xml = simpleXML_load_file($url);
}

function stopbath()
{
  $url = "http://192.168.1.100/sonos/sonos2.php?zonen=bad&action=mute&mute=true";
  $xml = simpleXML_load_file($url);
}

function stopall()
{
  $url = "http://192.168.1.100/sonos/sonos2.php?zonen=esszimmer&action=stop&stop=true";
  $xml = simpleXML_load_file($url);
  $url = "http://192.168.1.100/sonos/sonos2.php?zonen=wohnzimmer&action=stop&stop=true";
  $xml = simpleXML_load_file($url);
  $url = "http://192.168.1.100/sonos/sonos2.php?zonen=kueche&action=stop&stop=true";
  $xml = simpleXML_load_file($url);
  $url = "http://192.168.1.100/sonos/sonos2.php?zonen=bad&action=stop&stop=true";
  $xml = simpleXML_load_file($url);
  $url = "http://192.168.1.100/sonos/sonos2.php?zonen=esszimmer&action=ungroup";
  $xml = simpleXML_load_file($url);
  echo "sleep for 20 seconds" . $newLine;
  flush();
  sleep(20);
}

function playwindow()
{
  $url = "http://192.168.1.100/sonos/sonos2.php?zonen=esszimmer&action=group";
  $xml = simpleXML_load_file($url);
  flush();
  sleep(2); 
  $url = "http://192.168.1.100/sonos/sonos2.php?zonen=esszimmer&action=message&message=2";
  $xml = simpleXML_load_file($url);
}

function playautobath()
{
  $url = "http://192.168.1.100/sonos/sonos2.php?zonen=esszimmer&action=ungroup";
  $xml = simpleXML_load_file($url);
  flush();
  sleep(2);
  $url = "http://192.168.1.100/sonos/sonos2.php?zonen=bad&action=setradio";
  $xml = simpleXML_load_file($url);
  echo "sleep for 20 seconds" . $newLine;
  flush();
  sleep(20);
}

?>