<?php

#####################################################################################
#
# Version: 	0.4.1
# Datum: 	11.09.2013
# Verffentlicht im Forum: http://homematic-forum.de
# Username: dzvo
# 
# Bekannte Probleme:
# ------------------
# 
#
# 
# Anmerkungen:
# ------------
# - Volumen kann angegeben werden muss jedoch nicht, wenn keine Angabe wird Standard Lautstrke eingestellt 
# 
# Grundlegender URL Aufbau:
# -------------------------
# sonos2.php?zonen=SONOSPLAYER&action=BEFEHL&BEFEHL=Option
# Beispiele:
# sonos2.php?zonen=buero&action=play              			 	-> Absielen Starten
# sonos2.php?zonen=buero&action=pause							-> Abspielen Pausieren
# sonos2.php?zonen=buero&action=next							-> Nchster Titel
# sonos2.php?zonen=buero&action=previous						-> Verheriger Titel
# sonos2.php?zonen=buero&action=mute&mute=false					-> Sonos Laut schalten - false
# sonos2.php?zonen=buero&action=mute&mute=true					-> Sonos Leise schalten - true
# sonos2.php?zonen=buero&message=1&volumen=20					-> Nachricht 1 anspielen mit Lautstrke 20
# sonos2.php?zonen=buero&action=titelinfo						-> einfache HTML Playlist Anzeige
# sonos2.php?zonen=buero&action=addmember&member=kueche			-> Zone Kueche zur Zone Buero hinzufgen
# sonos2.php?zonen=buero&action=removemember&member=kueche		-> Zone Kueche aus der Zone Buero entfernen
# sonos2.php?zonen=schlafzimmer&action=sonosplaylist&playlist=Einschlafmusik&volume=1
# sonos2.php?zonen=schlafzimmer&action=stop
#
#
# zonen=			(wohnzimmer,buero,bad,kueche,schlafzimmer)	-> kleinschreibung, keine Leer oder Sonderzeichen
#		
# action=							
#		play													-> Abspielen
#		pause													-> Pause
#		next													-> nachster Titel
#		previous												-> vorheriger Titel
#		rewind													-> Beginn des Titels
# 		mute				(true,false)						-> Stumm schalten
#		stop													-> Absielen beenden
#		toggle													-> Play / Pause umschalten
#		playmode			(normal,shuffle_norepeat,
#								repeat_all,shuffle)				-> Abspielmodus
#		crossfade			(0,1)								-> Titelbergang aus, aus
#		remove				(Nummer des Titels)					-> Titel aus der Playlist lschen
#		clearqueue												-> Playlist lschen
#		playqueue												-> Absielen (nach Radiohhren) der aktuellen Playlist
#		volume				(0-100)								-> Lautstrke setzen
#		volumeup												-> Lautstrke um 3% erhhen
#		volumedown												-> Lautstrke um 5% verringern
#		addMember			(&member=SONOSZONE)					-> weitere Zone der Vorhanden hinzufgen
#		removemember		(&member=SONOSZONE)					-> vorhandene Zone entfernen
#		nextradio												-> nchsten Radiosender aus der Liste abspielen
#		prevradio												-> verherigen Radiosender aus der Liste absielen
#		sonosplaylist		(&playlist=SONOS Playlist)			-> Abspielen einer SONOS Playlist
#		radioplaylist		(&playlist=SONOS Radio Playlist)	-> Radioliste unter "Meine Radiosender" 
#		message				(&message=ZAHL&[volume=ZAHL])		-> Abspielen von Nachrichten z.B. ... 
#																	1.mp3 - Waschmaschiene ist ferig
#																	2.mp3 - Es hat geklingelt an der Tr
#																	3.mp3 -  ...
#		stopall													-> alle Zonen Musik beenden (Abwesenheit)							
#		telefon													-> Player wird angehalten und wieder abgespielt
#																   		im Gegensatz zu toggle wird die Wiedergabe nicht automatisch
#																		gestartet, sondern nur wenn vorher im Abspielmodus war.
#		group													-> alle Zonen mit einander Verbinden, die angegebene Zone ist der Master
#		ungroup													-> Alle Zonen auftrennen, Playlist lschen, Lautstrke Standard, Zeiger auf Playlist
#									
#									
######## Anzupassender Bereich #######################################################

# Hier kommem die einzelnen Sonos Player rein "name_kleingeschrieben" => "IP Adresse des Players"
$sonoszone = array(	"wohnzimmer" => "192.168.9.999",
					"bad"  => "192.168.9.999",
					"kueche"  => "192.168.9.999",
					"esszimmer"  => "192.168.9.999");
					
# Hier knnen eigene Radio Sender definiert werden, welche bei radionext oder radioprev angesteuert werden
# An der Stelle kommt nur der Stationsname rein.
$radio_name = array ( 	"1Live - Das junge Radio des WDR.");
					  
# und hier die URL zum Stationsnamen.
$radio_adresse = array ("x-rincon-mp3radio://wdr.de/wdrlive/media/einslive.m3u");

# Speicherort der Nachrichten zur Durchsage
$messagespeicher = "//DISKSTATION/iTunes/rwe";   # Windows Backslash \\ und Slash \ in Pfadangaben durch // und / ersetzen ohne Slash am Ende

# Standardlautstrke wenn nichts anderes mit angegeben wurde
$stdvolume = 20;

# Standardwert fr Lautstrkeeinstellen ber "Volumeup" & "Volumedown"
$volumeup = 40; # Lautstrke um 3 % lauter
$volumedown = 5; # Lautstrke um 5% leiser

# Standardlautstrke wenn nichts anderes angegeben wurde fr message durchsagen
$messagevolume = 50;

# Einstellungen zu Lautstrke
# Hier ist es mglich unterschiedliche Arten des Ansteigen der Lautstrke zu definieren
# z.B. sleep - fr den Wecker / Musik morgens, damit dieser langsamm lauter wird
#
# 	"sleep" 	- von aktueller Lautstrke auf die Ziel Lautstrke ndernd, fest eingestellt in 17 Sekunden.
#	"alarm" 	- von 0 auf die Ziel Lautstrke ansteigend.
#	"auto" 		- von 0 auf die Ziel Lautstrke ansteigend, sehr schnell und gleichmig.
#
$rampto = "alarm";

######## Script Code #######################################################

$debug = 0;
 if($debug == 1) { echo "<pre>"; }

include("PHPSonos.inc.php");


if(is_numeric($_GET['volume']) && $_GET['volume'] >= 0 && $_GET['volume'] <= 100) {
echo $volume;
	$volume = $_GET['volume'];
	}
	else {
	$volume = $stdvolume;
	}

if(isset($_GET['rampto'])) {
		switch($_GET['rampto'])
		{
			case 'sleep';
				$rampto = "SLEEP_TIMER_RAMP_TYPE";
				break;

			case 'alarm';
				$rampto = "ALARM_RAMP_TYPE";
				break;

			case 'auto';
				$rampto = "AUTOPLAY_RAMP_TYPE";
				break;
		}
	}
	else {
		switch($rampto)
		{
			case 'sleep';
				$rampto = "SLEEP_TIMER_RAMP_TYPE";
				break;

			case 'alarm';
				$rampto = "ALARM_RAMP_TYPE";
				break;

			case 'auto';
				$rampto = "AUTOPLAY_RAMP_TYPE";
				break;
		}

	}

if(array_key_exists($_GET['zonen'], $sonoszone))
{ 
	$zonen = $_GET['zonen'];
	$sonos = new PHPSonos($sonoszone[$zonen]); //Sonos IPAdresse

	switch($_GET['action'])
	{
		  
		case 'play';
			if(count($sonos->GetCurrentPlaylist()) > 0) { ;
				$sonos->RampToVolume($rampto, $volume);
				$sonos->Play();
			}
			else
			{
				die("Keine Titel in der Playlist zum abspielen.");
			}
			break;
		
		case 'pause';
				$sonos->Pause();
			break;
		
		case 'next';
			$titelgesammt = $sonos->GetPositionInfo();
			$titelaktuel = $titelgesammt["Track"];
			$playlistgesammt = count($sonos->GetCurrentPlaylist());
						
			if ($titelaktuel < $playlistgesammt) {
			$sonos->Next();
			}
			else
			{
				die("Kein wieter Titel in der Playlist");
			}
			break;

		case 'previous';
				$sonos->Previous();
			break;  

		case 'rewind':
				$sonos->Rewind();
			break; 

		case 'mute';
			if($_GET['mute'] == 'false') {
				$sonos->SetMute(false);
			}
			else if($_GET['mute'] == 'true') {
				$sonos->SetMute(true);
			}
			else {
				die('Falscher Mute Parameter');
			}       
			break;
			
		case 'stop';
				$sonos->Stop();
			break;      
		  
		case 'toggle':
			if($sonos->GetTransportInfo() == 1)  {
				$sonos->Pause();
			}
			else  {
				$sonos->Play();
			}
			break;  

		case 'telefon':

			function read($raum) {
			
			if( !@$datei = fopen($raum .".txt","r+") ) { 
				# Fehlerbehandlung erstellen der Datei
					$dateineu = fopen($raum .".txt","w+");
					rewind($dateineu);
					fwrite($dateineu, "");
					fclose($dateineu);
				}
				# Datei existiert
				$datei = fopen($raum .".txt","r+");
				$zustand = fgets($datei, 10);
			return $zustand;
			}
			
			function write($raum, $zustandneu) {
				$dateischreiben = fopen("" . $raum .".txt","w+");
				rewind($dateischreiben);
				fwrite($dateischreiben, $zustandneu);
				fclose($dateischreiben);
			}
		
			# 1 = PLAYING
			# 2 = PAUSED_PLAYBACK
			# 3 = STOPPED
				
				if($debug==1) {
					echo "Read: ".read($zonen)."<br>";
					echo "Transtort: " . $sonos->GetTransportInfo() . "<br>";
				}
				
			if(($sonos->GetTransportInfo() == 2 || $sonos->GetTransportInfo() == 3) && read($zonen) == 1 )  {
				$sonos->Play();
				write($zonen, 0);
			}
			
			if($sonos->GetTransportInfo() == 1 && read($zonen) == 0 )  {
			# Play
				$sonos->Pause();
				write($zonen, 1);
			}
					
	

		break;  

			
		case 'playmode';
		
			if( ($_GET['playmode'] == "normal") || ($_GET['playmode'] == "repeat_all") || ($_GET['playmode'] == "shuffle_norepeat") || ($_GET['playmode'] == "shuffle")  ) {
				$sonos->SetPlayMode(strtoupper($_GET['playmode']));
			}
			else {
				die('falscher PlayMode');
			}    
			break;           
	  
		case 'crossfade':
			if((is_numeric($_GET['crossfade'])) && ($_GET['crossfade'] == 0) || ($_GET['crossfade'] == 1)) { 
				$crossfade = $_GET['crossfade'];
			}
			else {
				die ("Falscher Playmode -> 0 = aus / 1 = an");
			}
				$sonos->SetCrossfadeMode($crossfade);
			break; 
		  
		case 'remove':
			if(is_numeric($_GET['remove'])) {
				$sonos->RemoveFromQueue($_GET['remove']);
			} 
			break;   
		
		case 'playqueue':
		
			$titelgesammt = $sonos->GetPositionInfo();
			$titelaktuel = $titelgesammt["Track"];
			$playlistgesammt = count($sonos->GetCurrentPlaylist());
						
			if ($titelaktuel < $playlistgesammt) {
			$sonos->SetQueue("x-rincon-queue:" . getRINCON($sonoszone[$zonen]) . "#0");
			$sonos->RampToVolume($rampto, $volume);
			$sonos->Play();
			}
			else {
				die("Keine Titel in der Playlist zum Abspielen.");
			}


			break;
		
		case 'clearqueue':
				$sonos->SetQueue("x-rincon-queue:" . getRINCON($sonoszone[$zonen]) . "#0");
				$sonos->ClearQueue();
			break;  
		  
		case 'volume':
			if(isset($volume)) {
				$sonos->SetVolume($volume);
			}
			else {
				die('falscher Wertebereich fr das Volume');
			}
			break;  
		  
		case 'volumeup': 
			$volume = $sonos->GetVolume();
			if($volume < 100) {
				$volume = $volume + $volumeup;
				$sonos->SetVolume($volume);
			}      
			break;
			  
		case 'volumedown':
			$volume = $sonos->GetVolume();
			if($volume > 0) {
				$volume = $volume - $volumedown;
			$sonos->SetVolume($volume);
			}
			break;      

		case 'addmember':
			if ($debug == 1) {
				echo debug();
			}
			
			if($debug == 1) {
				echo "<pre>";
				echo "Member IP: " . $sonoszone[$_GET['member']] . "<br>";
				echo "Member RINCON: " . getRINCON($sonoszone[$_GET['member']]). "<br>";
				echo "</pre>";
			}
			
			if(isset($_GET['member'])) {
				$AddMember = $sonos->AddMember(getRINCON($sonoszone[$_GET['member']])); # Member Rincon
				$sonos = new PHPSonos($sonoszone[$_GET['member']]); //Slave Sonos ZP IPAddress
				$ret = $sonos->SetAVTransportURI("x-rincon:" . getRINCON($sonoszone[$zonen])); // Master Sonos ZP IPAddress
			  } 
			else {
				die('Die Zone konnte nicht gefunden werden.');
			  }
			
			if($debug==1) {			
			  echo zonenmaster($_GET['member']);
			}
			
		  break;

		case 'removemember':

			if(isset($_GET['member'])) {
			
				if($debug ==1) {
				echo "zonen: " . $zonen . "<br>";
				echo "member: " . $_GET['member'] . "<br>";
				}
				
				# wenn Member gleich Zone ist 

				
				if ($zonen == $_GET['member']) {
				die("Der Master kann sich selber nicht entfernen.");
				}
				
				
				# nachschauen ob die Zone berhaupt verbunden ist
				$master = zonenmaster($_GET['member']);
				
				if (isset($master)) {
				#	$RemoveMember = $sonos->RemoveMember(getRINCON($sonoszone[$_GET['member']])); # Member Rincon
					$sonos = new PHPSonos($sonoszone[$_GET['member']]); //Slave Sonos ZP IPAddress
					$sonos->SetAVTransportURI("");
				}
				else {
					die("Der Player ist nicht mir dem Master verbunden.");
				}

		  }
		   else  {
			die('Die Zone konnte nicht gefunden werden.');
		  }
		  break;
//netsloh Begin		  
case 'setradio':
	$sonos->SetRadio($radio_adresse[0], $radio_name[0]);
	$sonos->RampToVolume($rampto, $volume);
	$sonos->Play();
	if( $debug == 1) {
		echo "Sender aktuell: " . $radio_adresse[0] . "<br>";
	}
	break;
//netsloh End
		case 'nextradio':
		
			$radiosender = $sonos->GetPositionInfo();
			$senderuri = $radiosender["URI"];
			$radioanzahl = $result = count($radio_name);
			
			$senderaktuell = array_search($senderuri,  $radio_adresse);
			
			# Wenn nextradio aufgerufen wird ohne eine vorherigen Radiosender
			if( $senderaktuell == "" && $senderuri == "" || substr($senderuri,0,12) == "x-file-cifs:" ) {
				$senderaktuell = -1;
				}
			
				if ($senderaktuell < ($radioanzahl) ) {
					$sonos->SetRadio($radio_adresse[$senderaktuell + 1], $radio_name[$senderaktuell + 1]);
				}
				
				if ($senderaktuell == $radioanzahl - 1) {

					$sonos->SetRadio($radio_adresse[0], $radio_name[0]);
				}
				
			if( $debug == 1) {
					echo "Senderuri vorher: " . $senderuri . "<br>";
					echo "Sender aktuell: " . $senderaktuell . "<br>";
					echo "Radioanzahl: " .$radioanzahl . "<br>";
				}
			
			$sonos->RampToVolume($rampto, $volume);
			$sonos->Play();
		
		  break;

		case 'prevradio':
		
			$radiosender = $sonos->GetPositionInfo();
			$senderuri = $radiosender["URI"];
			$radioanzahl = $result = count($radio_name);
			$senderaktuell = array_search($senderuri, $radio_adresse);
			
			# Wenn prevradio aufgerufen wird ohne eine vorherigen Radiosender
			if( $senderaktuell == "" && $senderuri == "" || substr($senderuri,0,12) == "x-file-cifs:") {
					$sonos->SetRadio($radio_adresse[$radioanzahl], $radio_name[$radioanzahl]);
				}
			
				if ($senderaktuell <= ($radioanzahl - 1) ) {
					$sonos->SetRadio($radio_adresse[$senderaktuell - 1], $radio_name[$senderaktuell - 1]);
				}
				if ($senderaktuell == 0) {
					$sonos->SetRadio($radio_adresse[$radioanzahl - 1], $radio_name[$radioanzahl - 1]);
				}
				
				if( $debug == 1) {
					echo "Senderuri vorher: " . $senderuri . "<br>";
					echo "Sender aktuell: " . $senderaktuell . "<br>";
					echo "Radioanzahl: " .$radioanzahl . "<br>";
				}
			$sonos->RampToVolume($rampto, $volume);	
			$sonos->Play();
		
		  break;
		  
		case 'sonosplaylist':
			if($debug == 1) {
				echo $sonoszone[$zonen] . "<br>";
				echo getRINCON($sonoszone[$zonen]) . "<br>";	
			}
		
			
			if(isset($_GET['playlist'])) {
				$sonos->SetQueue("x-rincon-queue:" . getRINCON($sonoszone[$zonen]) . "#0"); 
				$playlist = $_GET['playlist'];
			}
			else {
			  die ("Keine Liste mit dem Namen gefunden.");
			}
		
		# Sonos Playlist ermitteln und mit bergebene vergleichen	
		$sonoslists=$sonos->GetSONOSPlaylists();

			$pleinzeln = 0;
			while ( $pleinzeln < count($sonoslists) ) {
				if (debug == 1) {
					echo "Playlist " . $pleinzeln . "<br>\n\n";
					echo "ID: " . $sonoslists[$pleinzeln]["id"] . "<br>\n";
					echo "Titel: " . $sonoslists[$pleinzeln]["title"] . "<br>\n";
					echo "Typ: " . $sonoslists[$pleinzeln]["typ"] . "<br>\n";
					echo "File: " . $sonoslists[$pleinzeln]["file"] . "<br>\n";
					echo urldecode($sonoslists[$pleinzeln]["file"]) . "<br>\n";
					echo "ausgewhlte Liste: " . $liste . "<br>\n";
					echo "<br>\n";
				}
				
				if($playlist == $sonoslists[$pleinzeln]["title"]) {
					$plfile = urldecode($sonoslists[$pleinzeln]["file"]);

					#$zustand = "NORMAL";
					#$sonos->SetPlayMode($zustand);

					$sonos->ClearQueue();
					$sonos->AddToQueue($plfile); //Datei hinzufgen
					$sonos->SetQueue("x-rincon-queue:". getRINCON($sonoszone[$zonen]) ."#0"); 
					$sonos->RampToVolume($rampto, $volume);
					$sonos->Play();
					$gefunden = 1;
						
				}
				$pleinzeln++;
				if (($pleinzeln == count($sonoslists) ) && ($gefunden != 1)) {
					die("Keine Liste mit dem Namen gefunden.");
				}
			}			
		  
		  break;

		case 'radioplaylist':
			
			if(isset($_GET['playlist'])) {
				$playlist = $_GET['playlist'];
			}
			else {
			  die ("Keine Radio Playlist gefunden.");
			}
			# Sonos Radio Playlist ermitteln und mit bergebene vergleichen	
			$radiolists = $sonos->Browse("R:0/0","c");

			$rleinzeln = 0;
			while ( $rleinzeln < count($radiolists) ) {
				if (debug == 1) {
					echo "Radioliste " . $rleinzeln . "<br>\n\n";
					echo "ID: " . $radiolists[$rleinzeln]["id"] . "<br>\n";
					echo "Titel: " . $radiolists[$rleinzeln]["title"] . "<br>\n";
					echo "Typ: " . $radiolists[$rleinzeln]["typ"] . "<br>\n";
					echo "File: " . $radiolists[$rleinzeln]["res"] . "<br>\n";
					echo urldecode($radiolists[$rleinzeln]["res"]) . "<br>\n";
					echo "ausgewhlter Radiosender: " . $playlist . "<br>\n";
					echo "<br>\n";
				}
				
						if (urldecode($playlist) == $radiolists[$rleinzeln]["title"]) {
													
							$sonos->SetRadio(urldecode($radiolists[$rleinzeln]["res"]));
							$sonos->RampToVolume($rampto, $volume);
							$sonos->play();
						}
			$rleinzeln++;
			}	

		break;
		
		case 'titelinfo':
		
			if($debug == 1) {
				echo debug();
			}

			$PositionInfo = $sonos->GetPositionInfo();
			$GetMediaInfo = $sonos->GetMediaInfo();

			$title = $PositionInfo["title"];
			$album = $PositionInfo["album"];
			$artist = $PositionInfo["artist"];
			$albumartist = $PositionInfo["albumArtist"];
			$reltime = $PositionInfo["RelTime"];
			$bild = $PositionInfo["albumArtURI"];
		
		
				echo'
					<table>
						<tr>
							<td><img src="' . $bild . '" width="200" height="200" border="0"></td>
							<td>
							Titel: ' . $title . '<br><br>
							Album: ' . $album . '<br><br>
							Artist: ' . $artist . '</td>
						</tr>
						<tr>
						<td>
						<a href="'.$_SERVER['SCRIPT_NAME'].'?zonen='.$zonen.'&action=previous" target="_blank">Zurck</a>
						<a href="'.$_SERVER['SCRIPT_NAME'].'?zonen='.$zonen.'&action=play" target="_blank">Abspielen</a>
						<a href="'.$_SERVER['SCRIPT_NAME'].'?zonen='.$zonen.'&action=pause" target="_blank">Pause</a>
						<a href="'.$_SERVER['SCRIPT_NAME'].'?zonen='.$zonen.'&action=stop" target="_blank">Stop</a>
						<a href="'.$_SERVER['SCRIPT_NAME'].'?zonen='.$zonen.'&action=next" target="_blank">Nchster</a>
						
					</table>
				';
					
			break;
		  
		case 'message':
			if(isset($_GET['message']) )
			{
				$message = $_GET['message'];
				
				if(isset($_GET['volume']) && is_numeric($_GET['volume']) && $_GET['volume'] >= 0 && $_GET['volume'] <= 100) {
					$volume = $_GET['volume'];
				}
				else
				{
					$volume = $messagevolume;
				}
			
				 # Einstellungen speichern
					$save_MediaInfo = $sonos->GetMediaInfo();
					$save_PositionInfo = $sonos->GetPositionInfo();
					$save_Mute =$sonos->GetMute();
					$save_Vol = $sonos->GetVolume();
					$save_Status = $sonos->GetTransportInfo();
					$save_TransportSettings = $sonos->GetTransportSettings();
					$save_GetCurrentPlaylist = $sonos->GetCurrentPlaylist();

					
					if ($debug == 1) {
						echo '<PRE>';
						echo '<br />GetPositionInfo:';
						print_r($save_PositionInfo);
						echo '<br />GetCurrentPlaylist:';
						#print_r ($save_GetCurrentPlaylist);
						echo "<br />Anzahl Playlist Lieder: " . count($save_GetCurrentPlaylist) . "<br />";
						echo '<br />GetMediaInfo:';
						print_r ($save_MediaInfo); // Radio
						echo '<br />GetMute:';
						print_r ($save_Mute);
						echo '<br />GetVolume:';
						print_r ($save_Vol);
						echo '<br />GetTransportInfo:';
						print_r ($save_Status);
						echo '<br />GetTransportSettings:';
						print_r ($save_TransportSettings);    
						echo '</PRE>';
					}

					# Es luft eine Radiostation
					# Wenn Radio luft, muss zuerst die Liste wieder aktiviert werden
					if (substr($save_PositionInfo["TrackURI"], 0, 17) == "x-rincon-mp3radio")
					{  
						# zum Wiederherstellen es lief ein Radio Sender
						$wiederherstellen = "Radio";
						$message_pos = count($save_GetCurrentPlaylist) + 1;
						$sonos->SetQueue("x-rincon-queue:" . getRINCON($sonoszone[$zonen]) . "#0"); //Playliste aktivieren
					}
					elseif (substr($save_PositionInfo["TrackURI"], 0, 11) == "x-file-cifs") // Es luft eine Musikliste 
					{
						$wiederherstellen = "Playlist";
						$message_pos = count($save_GetCurrentPlaylist) + 1;
					}
					elseif ($save_PositionInfo["TrackURI"] == "" ) {
						
						# es wird keine Musik abgespielt, also einfach nur nachricht abspielen
						$message_pos = count($save_GetCurrentPlaylist) + 1;
					}
					
					$sonos->AddToQueue("x-file-cifs:" . $messagespeicher . "/" . $message . ".mp3");

					//Auf den neuen Track zeigen
					$sonos->SetTrack($message_pos);
					$sonos->SetMute(false);
					$sonos->SetVolume($volume);
					$sonos->Play();   // Abspielen

					$abort = false;

					# Prfen ob Meldung zu ende gespielt ist
					do {
						# Infos zur Message einlesen
						$message_PositionInfo = $sonos->GetPositionInfo();
			
							if ($message_PositionInfo["RelTime"] == $message_PositionInfo["TrackDuration"] ) {
								if($debug == 1) {
								#	echo "message Laufzeit aktuell: " . $message_PositionInfo["RelTime"] . "<br>";
								#	echo "message Laufzeit gesammt: " . $message_PositionInfo["TrackDuration"] . "<br>";
								}
								sleep(1);
								$abort = true; // Message fertig
							}
					} # do
					
					while($abort == false);
					
							#Message wieder aus Queue entfernen
							$sonos->RemoveFromQueue($message_pos);
						
						# Wieder alten Zustand herstellen
						if ($wiederherstellen == "Playlist" ){
							
							// alte Playlist weiterspielen
							$sonos->SetTrack($save_PositionInfo["Track"]);
							$sonos->Seek($save_PositionInfo["RelTime"],"NONE");
							$sonos->SetVolume($save_Vol);
							$sonos->SetMute($save_Mute);
							
							# Wenn alte Playlist in Pause war dann Pause setzen an sonsten Play
							# save_Status //1 = PLAYING //2 = PAUSED_PLAYBACK //3 = STOPPED
							# $save_TransportSettings  repeat shuffle ...	
							
							# wenn Repeat oder Shuffle aktiviert ist und die Musik nicht luft, 
							# muss die Pause gesetzt werden, da sonst die Musik anluft
							if($save_Status != 1 && ($save_TransportSettings['shuffle'] == 1 || $save_TransportSettings['repeat'] == 1)) {
								$sonos->Pause();
								}  

							if ($save_Status == 1) {            
								  $sonos->Play();
								}
							if ($save_Status == 3 ) {
								$sonos->Stop();
								}
							
						}elseif ($wiederherstellen == "Radio" ){
							
							# je nach dem ob Radio vorhier Lief oder nicht Zustand wieder herstellen.
							# save_Status //1 = PLAYING //2 = PAUSED_PLAYBACK //3 = STOPPED
							# $save_TransportSettings  repeat shuffle ...	
							
							# alten Radiosender weiterspielen
							
								$sonos->SetRadio($save_PositionInfo["URI"], $save_MediaInfo["title"]);
								$sonos->SetVolume($save_Vol);
								$sonos->SetMute($save_Mute);
								
								if($save_Status == 1) {
									$sonos->Play();
							}
						}
				} 
			else
			{
				die ("Keine Nachricht, keine Lautstrke angegeben oder falsche Werte angegeben.");
			}
	
    break;
	
	case 'group':
		
		# Zonen zusamenfgen
			$masterrincon = getRINCON($sonoszone[$zonen]);
			$sonos->SetVolume($volume);
					
			foreach ($sonoszone as $zone => $ip) {
				
					if($zone != $_GET['zonen']) {
						$sonos = new PHPSonos($ip); 
						$sonos->SetVolume($volume);
						$sonos->SetAVTransportURI("x-rincon:" . $masterrincon); 
					}	
			}
		
	break;
		
	case 'ungroup':
		
			
		
		foreach($sonoszone as $zonen => $ip)
		{
			$sonos = new PHPSonos($sonoszone[$zonen]); //Sonos IPAdresse
			$sonos->SetQueue("x-rincon-queue:" . getRINCON($sonoszone[$zonen]) . "#0");
			$sonos->SetVolume($volume);
			$sonos->ClearQueue();
			$sonos->Stop();
		}
	
	
	break;
	
					
	
	# Debug Bereich ------------------------------------------------------
		case 'getmedianfo':
				echo '<PRE>';
				print_r($sonos->GetMediaInfo());
				echo '</PRE>';
			break;

		case 'getpositioninfo':
				echo '<PRE>';
				print_r($sonos->GetPositionInfo());
				echo '</PRE>';
			break;      

		case 'gettransportsettings':
				echo '<PRE>';
				print_r($sonos->GetTransportSettings());
				echo '</PRE>';
			break;   
		  
		case 'gettransportinfo':
			# 1 = PLAYING
			# 2 = PAUSED_PLAYBACK
			# 3 = STOPPED

				echo '<PRE>';
					print_r($sonos->GetTransportInfo());
				echo '</PRE>';
			break;        
		
		case 'getradiotimegetnowplaying':
				$radio = $sonos->RadiotimeGetNowPlaying();
				print_r($radio);
			break;
		  
		case 'getvolume':
				echo '<PRE>';
					print_r($sonos->GetVolume());
				echo '</PRE>';
			break;
		  
	
		case 'masterplayer':
		
			foreach ($sonoszone as $player => $ip) {

				$sonos = new PHPSonos($ip); //Slave Sonos ZP IPAddress
				$temp = $sonos->GetPositionInfo();

				if (substr($temp["TrackURI"], 0, 9) == "x-rincon:" ) {
					$masterrincon = substr($temp["TrackURI"], 9 ,24);
					}
				
				foreach ($sonoszone as $masterplayer => $ip) {
					if(getRINCON($ip) == $masterrincon) {
						echo "<br>" . $player . " -> ";
						echo "Master des Players: " . $masterplayer;
					}
				}
				$masterrincon = "";
			}
			break;
		

		  
	default:
       die("Dieser Befehl ist nicht bekannt. <br>sonos2.php?zonen=SONOSPLAYER&action=BEFEHL&BEFEHL=Option");


	} # switch
	
	
}
else {
	echo "Der Zonen ist nicht im anzupassen Bereich vorhanden.";
	}



 # Funktionen
 
 function getRINCON($zoneplayerIp) {
  $url = "http://" . $zoneplayerIp . ":1400/status/zp";
  $xml = simpleXML_load_file($url);  
  $uid = $xml->ZPInfo->LocalUID;
  return $uid;  
}


 function zonenmaster($member) {
		global $sonos, $sonoszone;
			
		foreach ($sonoszone as $player => $ip) {
			#echo "<br>" . $player;
			$sonos = new PHPSonos($ip); //Slave Sonos ZP IPAddress
			$temp = $sonos->GetPositionInfo();

			if (substr($temp["TrackURI"], 0, 9) == "x-rincon:" ) {
				$masterrincon = substr($temp["TrackURI"], 9 ,24);
				}
			
			foreach ($sonoszone as $masterplayer => $ip) {
				if(getRINCON($ip) == $masterrincon) {
					if ($member == $player) {
				#	echo "<br>" . $player . " -> ";
				#	echo "Master des Players: " . $masterplayer;
					return  $masterplayer;				
					}
				}
			}
			unset($masterrincon);
			unset($sonos);
		}
	
 }


 function debug() {
 
	global $sonos, $sonoszone;
 
	$GetPositionInfo = $sonos->GetPositionInfo();
	$GetMediaInfo = $sonos->GetMediaInfo();
	$GetTransportInfo = $sonos->GetTransportInfo();
	$GetTransportSettings = $sonos->GetTransportSettings();
	$GetCurrentPlaylist = $sonos->GetCurrentPlaylist();
	
	echo '<PRE>';
	echo '<br />GetPositionInfo:';
	print_r($GetPositionInfo);

	echo '<br />GetMediaInfo:';
	print_r ($GetMediaInfo); // Radio

	echo '<br />GetTransportInfo:';
	print_r ($GetTransportInfo);
	
	echo '<br />GetTransportSettings:';
	print_r ($GetTransportSettings);  
	
	echo '<br />GetCurrentPlaylist:';
	print_r ($GetCurrentPlaylist);
	echo '</PRE>';
}

 if($debug == 1) { echo "</pre>"; }




?>